## com.icl.saxon.functions
Class Document

    java.lang.Object
      com.icl.saxon.expr.Expression
          com.icl.saxon.expr.Function
              com.icl.saxon.functions.Document

public class Document
extends Function

Field Summary

Fields inherited from class com.icl.saxon.expr.Function
`argument`

Fields inherited from class com.icl.saxon.expr.Expression
`staticContext`

Constructor Summary
`Document()`

Method Summary
`Value` `evaluate(Context c)` evaluate() handles evaluation of the function
`int` `getDataType()` Determine the data type of the expression
`int` `getDependencies()` Determine which aspects of the context the expression depends on.
`NodeSetValue` `getDocuments(Value arg0, NodeSetValue arg1, java.lang.String styleSheetURL, Context context)` getDocuments() evaluates the function.
`java.lang.String` `getName()` Get the name of the function.
`Expression` `reduce(int dep, Context context)` Remove dependencies.
`Expression` `simplify()` Simplify and validate.

Methods inherited from class com.icl.saxon.expr.Function
`addArgument, checkArgumentCount, display, getNumberOfArguments`

Methods inherited from class com.icl.saxon.expr.Expression
`containsReferences, enumerate, evaluateAsBoolean, evaluateAsNodeSet, evaluateAsNumber, evaluateAsString, getStaticContext, indent, isContextDocumentNodeSet, make, outputStringValue, setStaticContext, usesCurrent`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Document

    public Document()

Method Detail

### getName

    public java.lang.String getName()

  Description copied from class: `Function`
  Get the name of the function. This method must be implemented in all subclasses.

  Specified by:
    `getName` in class `Function`
  Returns:
    the name of the function, as used in XSL expressions, but excluding its namespace prefix

### getDataType

    public int getDataType()

  Determine the data type of the expression

  Specified by:
    `getDataType` in class `Expression`
  Returns:
    Value.NODESET

### simplify

    public Expression simplify()
                        throws XPathException

  Simplify and validate.

  Overrides:
    `simplify` in class `Expression`
  Returns:
    the simplified expression
  Throws:
    `XPathException`

### evaluate

    public Value evaluate(Context c)
                   throws XPathException

  evaluate() handles evaluation of the function

  Specified by:
    `evaluate` in class `Expression`
  Parameters:
    `c` - The context in which the expression is to be evaluated
  Returns:
    the value of the expression, evaluated in the current context
  Throws:
    `XPathException`

### getDocuments

    public NodeSetValue getDocuments(Value arg0,
                                     NodeSetValue arg1,
                                     java.lang.String styleSheetURL,
                                     Context context)
                              throws XPathException

  getDocuments() evaluates the function.

  Parameters:
    `arg0` - The value of the first argument
    `arg1` - The value of the second argument, if there is one; otherwise null
    `styleSheetURL` - The URI of the node in the stylesheet containing the expression. Needed only when the first argument is not a nodeset and the second argument is omitted.
    `context` - The evaluation context
  Returns:
    a NodeSetValue containing the root nodes of the selected documents (or element nodes if the URI references contain fragment identifiers)
  Throws:
    `XPathException`

### getDependencies

    public int getDependencies()

  Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as Context.VARIABLES and Context.CURRENT_NODE

  Specified by:
    `getDependencies` in class `Expression`

### reduce

    public Expression reduce(int dep,
                             Context context)
                      throws XPathException

  Remove dependencies.

  Specified by:
    `reduce` in class `Expression`
  Parameters:
    `dep` - The dependencies to be removed, e.g. Context.VARIABLES
    `context` - The context to be used for the partial evaluation
  Returns:
    a new expression (or Value) that does not have any of the specified dependencies
  Throws:
    `XPathException`